/***/
import { NrDataTransformer } from "nr-data-transtormer";
import { IGroupByObject } from "./i-group-by-object";
import { IGroupByCondition } from "./i-group-by-condition";
import { IDataSource } from "./i-data-source";
import { ITemplatePart } from "./i-template-part";
import { ISortField } from "./i-sort-field";
import { AggregateType } from "./aggregate-type";
export declare class NrStringRender {
    /***/
    transformer: NrDataTransformer<{}>;
    /***/
    constructor();
    /**Генерация отчета для источников данных*/
    renderReport(template: string, dataSources: IDataSource[]): string;
    /***/
    replaceParam(param: object, renderCanvas: string): string;
    /***/
    getGroupByDataSources(template: string, dataSources: IDataSource[]): IDataSource[];
    /**Генерация отчета для одного источника данных*/
    renderDataSourceRec(dataSourceName: string, dataSourceData: any[], template: string): string;
    /***/
    calcAggregateDataSource(dataSourceName: string, dataSourceData: any[], template: string): string;
    /***/
    calcAggObject(row: Object, path: string[], aggregateType: AggregateType): any;
    /***/
    calcAgg(rows: Object[], path: string[], aggregateType: AggregateType): number;
    /***/
    sortDataSourceData(dataSourceData: any[], fields: ISortField[]): void;
    /***/
    getTemplatePart(dataSourceName: string, template: string): ITemplatePart[];
    /***/
    getSortFields(template: string): ISortField[];
    /**Убираем из шаблона указатели на источник данных*/
    removeDataSourceMarker(templatePart: string, dataSourceName: string): string;
    /**Из шаблона генерим пачку интерполированных шаблонов*/
    renderDataSource(dataSourceName: string, dataSourceData: any[], template: string): string;
    /***/
    replaceValueOnTemplate(fieldName: string, template: string, valueToReplace: any): string;
    /***/
    formatApp(date: Date): string;
    /***/
    getGroupByObjects(template: string): IGroupByObject[];
    /***/
    removeGroupByFromTemplate(template: string): string;
    /***/
    getGroupByCondition(groupByCondition: string): IGroupByCondition;
    /***/
    getGroupByFields(groupFields: string): string[];
    /***/
    getLeafPath(obj: Object, selfKey?: string): string[];
    /***/
    extractDataFromObject(obj: Object, path: string): any;
}
